/*                                               */
/* Programme C: arbres-main.c                    */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/*  Main pour tester les arbres binaires.        */

#include <stdio.h>
#include "arbres.h"

int main(int argc, char *argv[])
{
FILE *pfi,*pfo;
intlist l;
intarbre a,t;

 if (argc<2) {printf("Usage: arbres nomdefichier\n");exit(1);};
 if ((pfo=fopen(argv[1],"w"))==NULL)
    {printf("Impossible d'ouvrir le fichier de sortie\n"); exit(1);}

 a=node(1,node(2,node(3,empty(),empty()),empty()),node(4,empty(),empty()));

 l=append_it(lofa(a),lofa(a));

 printintlist(l);printf("\n");

 list_to_file(pfo,l);
 arbre_to_file(pfo,a);

 fclose(pfo);

 if ((pfi=fopen(argv[1],"r"))==NULL)
    {printf("Impossible d'ouvrir le fichier d'entree\n"); exit(1);}
 printintlist(file_to_list(pfi)); printf("\n");
 printintlist(lofa(file_to_arbre(pfi))); printf("\n ---------\n");;
 fclose(pfi);

 printf("Voila la liste des noeuds de l'arbre a\n");
 printintlist(lofa(a));
 printf("\n");;
 swap(&(a->fg),&(a->fd));
 printf("On a opere un swap sur l'arbre a\n");
 printintlist(lofa(a));
 printf("\n");;
 exit(0);
}
