/*                                               */
/* Programme C: arbres.h                         */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/* Interface pour arbres.c                       */

#include "listes.h"
/* definition d'un noeud d'un arbre binaire */
typedef struct nodearbre {
		int data;
		struct nodearbre *fg;
		struct nodearbre *fd;
} nodearbre, *intarbre;

/* constructeurs pour arbres */

intarbre empty();

intarbre node(int data,intarbre g, intarbre d);


/* test pour arbres */

int isempty (intarbre a);

intlist lofa(intarbre a);

void swap (intarbre *a, intarbre *b);

void arbre_to_file(FILE *fp, intarbre a);

intarbre file_to_arbre(FILE *fp);

