/*                                               */
/* Programme C: listes-main.c                    */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/*  Main pour tester les listes d'entiers.       */

#include <stdio.h>
#include "listes.h"

int main(int argc, char *argv[])
{
FILE *pfi,*pfo;
intlist l;

 if (argc<2) {printf("Usage: listes nomdefichier\n");exit(1);};
 if ((pfo=fopen(argv[1],"w"))==NULL)
    {printf("Impossible d'ouvrir le fichier de sortie\n"); exit(1);}
 l=(cons(1,cons(2,cons(3,nil()))));
 printintlist(append(l,l)); printf("\nMaintenant j'ecris cette liste dans le fichier %s.\n",argv[1]);
 list_to_file(pfo,append(l,l));
 fclose(pfo);

 if ((pfi=fopen(argv[1],"r"))==NULL)
    {printf("Impossible d'ouvrir le fichier d'entree\n"); exit(1);}
 printf("\nRelecture de la liste depuis le fichier %s.\n",argv[1]);
 printintlist(file_to_list(pfi));printf("\n");
 fclose(pfi);
 exit(0);
}
