/*                                               */
/* Programme C: listes.h                         */
/* pour les cours d'Informatique                 */
/* de l'Universite de Paris VII                  */
/*                                               */
/* (C) 2000 R. Di Cosmo (roberto@dicosmo.org)    */
/*                                               */
/* Programme distribue sous licence GPL          */
/*                                               */
/* Interface pour listes.c                       */

/* definition d'un noeud d'une liste */
typedef struct nodelist {
	int data;
        struct nodelist *suivant;
} nodelist, *intlist;

/* constructeurs pour listes */

intlist nil();

intlist cons(int data,intlist l);

/* test sur listes */

int isnil(intlist l);

/* fonctions (recursives ou pas) sur des listes */

/* attention, cette fonction fait UNE copie de l1, qu ise termine par un pointeur a l2 */
intlist append(intlist l1,intlist l2);

/* attention, cette fonction MODIFIE EN PLACE l1, pour qu'elle pointe sur l2 */
intlist append_it(intlist l1,intlist l2);

/* parcours d'une liste, et impression */
void printintlist (intlist l);

void list_to_file(FILE *fp, intlist l);

intlist file_to_list(FILE *fp);
